//+------------------------------------------------------------------+
//|                                             MultiScreenShot.mq4  |
//+------------------------------------------------------------------+

#import "user32.dll"
int GetParent(int hWnd);
#import

#import "shell32.dll"
int ShellExecuteA(int hwnd,string Operation,string File,string Parameters,string Directory,int ShowCmd);
#import

#include <WinUser32.mqh>

#define VK_F11 0x7A
#define DELAY  500 //1/2 sec

int P;
int hwnd, rc;
string ImageName, Parameters;

int PTimeFrame[] = {1,5,15,30,60,240,1440,10080,43200};
string PTimeFrameDescriptionShort[] = {"1Min","5Min","15Min","30Min","1H","4H","Daily","Weekly","Monthly"};

void start()
{
   P = Period(); //Current Timeframe
  
   //The following will toggle through all of the possible Timeframes.
   for(int j = 0;j < ArraySize(PTimeFrame);j++)
   {
      hwnd = WindowHandle( Symbol(), P);
      
      //Only do something with the Timeframe if it exists for the given profile.
      if (hwnd > 0)
      {
         Window.activate(hwnd);
         Window.maximize(hwnd);

         //The following logic will simulate pressing F11, to display chart in Full screen. This is so the 
         //screen shot will ONLY include the chart
         keybd_event(VK_F11,0,0,0);
         Sleep(10);
         keybd_event(VK_F11,0,2,0);

         ImageName = StringConcatenate(Symbol(),"_",
                                       PTimeFrameDescriptionShort[ArrayBsearch(PTimeFrame,P)]);
          
         Parameters = "/file="+ImageName;

         //Screen is maximised, at this point - call screen shot etc
         
         //Gadwin Printscreen has been configured for all of the common parameters. However, we need to specify 
         //the name of the screen shot. This can't be done at the same time as performing the actual screenprint.
         rc = ShellExecuteA(0, 
                              "open",
                              "C:\Program Files (x86)\Gadwin Systems\PrintScreen\PrintScreen.exe", 
                              Parameters,
                              "",
                              1);
         Sleep(DELAY);

         //Perform the screenshot
         rc = ShellExecuteA(0, 
                              "open",
                              "C:\Program Files (x86)\Gadwin Systems\PrintScreen\PrintScreen.exe", 
                              "/justnow",
                              "",
                              1);
         Sleep(DELAY);

         //Exit out, so next time it is ready to be modified for the next screen name
         rc = ShellExecuteA(0, 
                              "open",
                              "C:\Program Files (x86)\Gadwin Systems\PrintScreen\PrintScreen.exe", 
                              "/exit",
                              "",
                              1);

         Sleep(DELAY);

         //Issue F11 to display chart in Normal Screen    
         keybd_event(VK_F11,0,0,0);
         Sleep(10);
         keybd_event(VK_F11,0,2,0);

         //Get Next Timeframe
         P = getNextTimeframe(P);
      }
   }

}

//+---------------------------------------------------------------------+
//+                                                                     +
//+   getNextTimeframe                                                  +
//+                                                                     +
//+   Identify the higher timeframe for a given timeframe               +
//+                                                                     +
//+---------------------------------------------------------------------+
int getNextTimeframe(int TimeFrame)
{
   int NextTF, TFMaxPos, TFPos;
   
   TFMaxPos = ArraySize(PTimeFrame) - 1;
   TFPos = ArrayBsearch(PTimeFrame,TimeFrame);
   
   //Are we currently on the last element in the Time Frame Array
   if (TFPos == TFMaxPos)
      return(-1);
   
   NextTF = PTimeFrame[TFPos + 1];

   return(NextTF);
}

//+-------------------------------------------------------------------------------+

int Window.activate(int hwnd) {
   int p = GetParent(hwnd);
   SendMessageA(GetParent(p), WM_MDIACTIVATE, p, 0);
}
int Window.maximize(int hwnd) {
   int p = GetParent(hwnd);
   SendMessageA(GetParent(p), WM_MDIMAXIMIZE, p, 0);
}